!
! DARKBAT     Dark frame subtract utility.
! Copyright (C) 1997-2004  Filip Hroch, Masaryk University, Brno, CZ
!
! $Id: darkbat.f90,v 1.2 2005/01/02 19:54:14 hroch Exp $ 
!

program darkbat
  
  implicit none

  character(len=666) :: line,sci,darkframe,outname,mask="darkbat.fits"
  character(len=15) :: format
  integer :: icit = 1
  integer :: ieql, j, n, result

  do
     read(*,'(a)',end=90) line
!     write(*,*) trim(line)     

     ieql = index(line,'=') + 1
     if( index(line,'DARKFRAME') > 0 ) then

       darkframe = line(ieql:)

     else if( index(line,'SCIFRAME') > 0 )then

       sci =  line(ieql:)

     else if( index(line,'MASK') > 0 )then

       mask =  line(ieql:)

     else if( index(line,'ICIT') > 0 )then

       read(line(ieql:),*) icit

    endif

 enddo
90 continue

 j = index(mask,"?")
 if ( j > 0 )then

    do n = 0, len_trim(mask)
       if( mask(j+n:j+n) /= '?' ) exit
    enddo
    write(format,"(A,I1.1,A,I1.1,A)") "(I",n,".",n,")"
    write(mask(j:j+n-1),format) icit

 endif

 outname = mask

! write(*,'(3a20)') sci,darkframe,outname
 call dark(sci,darkframe,outname,result)
 if( result == 0 ) then
    write(*,'(a)') trim(outname)
 else
    write(*,'(a)') ''
 endif

end program darkbat
